# -*- coding: utf-8 -*-

"""
akoyaapisv240

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from akoyaapisv240.api_helper import APIHelper
from akoyaapisv240.configuration import Server
from akoyaapisv240.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from akoyaapisv240.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from akoyaapisv240.models.array_of_account_payment_networks import ArrayOfAccountPaymentNetworks
from akoyaapisv240.exceptions.error_exception import ErrorException
from akoyaapisv240.exceptions.api_exception import APIException


class PaymentsController(BaseController):

    """A Controller to access Endpoints in the akoyaapisv240 API."""
    def __init__(self, config):
        super(PaymentsController, self).__init__(config)

    def payment_networks(self,
                         version,
                         provider_id,
                         account_id,
                         x_akoya_interaction_type=None):
        """Does a GET request to /payments/{version}/{providerId}/{accountId}payment-networks.

        This product supports use cases such as payment enablement or account
        opening. The response includes identifiers necessary to make ACH and
        RTP payments. Identifiers include account number, routing number,
        identifier type (actual or tokenized account number), and payment
        network type such as ACH or RTP.
        <br>
        To see the response schema, select the `200` response below. For an
        example payload response, see the `200` example response below the
        *Try it* feature. 
        > 🛑
        > 
        > The *id_token* should be used as the bearer token with this call.

        Args:
            version (str): Akoya major version number. Do not use minor
                version numbers. For instance, use v2 and not v2.2
            provider_id (str): Id of provider
            account_id (str): Account Identifier
            x_akoya_interaction_type (XAkoyaInteractionTypeEnum, optional):
                Optional but recommended header to include with each data
                request.  Allowed values are `user` or `batch`.  `user`
                indicates a request is prompted by an end-user action. `batch`
                indicates the request is part of a batch process.

        Returns:
            ArrayOfAccountPaymentNetworks: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/payments/{version}/{providerId}/{accountId}payment-networks')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('version')
                            .value(version)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('providerId')
                            .value(provider_id)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('accountId')
                            .value(account_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('x-akoya-interaction-type')
                          .value(x_akoya_interaction_type))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('acgAuth'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(ArrayOfAccountPaymentNetworks.from_dictionary)
            .local_error('401', '602 - Customer does not have authorization to perform this action. The customer may have revoked access through the provider and would need to reauthenticate.', ErrorException)
            .local_error('403', '403 - The `providerId` is wrong or your app doesn\'t have a subscription to the provider.', ErrorException)
            .local_error('404', '701 - Account not found. The `accountId` may be wrong.', ErrorException)
            .local_error('405', 'Method Not Allowed', APIException)
            .local_error('408', 'Request timed out (round trip call took >10 seconds).', ErrorException)
        ).execute()
