# -*- coding: utf-8 -*-

"""
akoyaapisv240

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from akoyaapisv240.api_helper import APIHelper
from akoyaapisv240.models.account_holder_entity import AccountHolderEntity


class AccountContactEntity(object):

    """Implementation of the 'Account Contact entity' model.

    Contact information for the account

    Attributes:
        holders (List[AccountHolderEntity]): Owners of the account
        emails (List[str]): Email addresses associated with the account

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "holders": 'holders',
        "emails": 'emails'
    }

    _optionals = [
        'holders',
        'emails',
    ]

    def __init__(self,
                 holders=APIHelper.SKIP,
                 emails=APIHelper.SKIP):
        """Constructor for the AccountContactEntity class"""

        # Initialize members of the class
        if holders is not APIHelper.SKIP:
            self.holders = holders 
        if emails is not APIHelper.SKIP:
            self.emails = emails 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        holders = None
        if dictionary.get('holders') is not None:
            holders = [AccountHolderEntity.from_dictionary(x) for x in dictionary.get('holders')]
        else:
            holders = APIHelper.SKIP
        emails = dictionary.get("emails") if dictionary.get("emails") else APIHelper.SKIP
        # Return an object of this model
        return cls(holders,
                   emails)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'holders={(self.holders if hasattr(self, "holders") else None)!r}, '
                f'emails={(self.emails if hasattr(self, "emails") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'holders={(self.holders if hasattr(self, "holders") else None)!s}, '
                f'emails={(self.emails if hasattr(self, "emails") else None)!s})')
