# -*- coding: utf-8 -*-

"""
akoyaapisv240

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from akoyaapisv240.api_helper import APIHelper
from akoyaapisv240.models.customer_1 import Customer1


class AccountHolderEntity(object):

    """Implementation of the 'Account Holder entity' model.

    Extends `Customer` and adds a `relationship` field to define the
    customer's relationship with an account

    Attributes:
        customer (Customer1): Represents a customer (end-user)
        relationship (AccountHolderRelationship2Enum): Customer's relationship
            to the account

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "customer": 'customer',
        "relationship": 'relationship'
    }

    _optionals = [
        'customer',
        'relationship',
    ]

    def __init__(self,
                 customer=APIHelper.SKIP,
                 relationship=APIHelper.SKIP):
        """Constructor for the AccountHolderEntity class"""

        # Initialize members of the class
        if customer is not APIHelper.SKIP:
            self.customer = customer 
        if relationship is not APIHelper.SKIP:
            self.relationship = relationship 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        customer = Customer1.from_dictionary(dictionary.get('customer')) if 'customer' in dictionary.keys() else APIHelper.SKIP
        relationship = dictionary.get("relationship") if dictionary.get("relationship") else APIHelper.SKIP
        # Return an object of this model
        return cls(customer,
                   relationship)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'customer={(self.customer if hasattr(self, "customer") else None)!r}, '
                f'relationship={(self.relationship if hasattr(self, "relationship") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'customer={(self.customer if hasattr(self, "customer") else None)!s}, '
                f'relationship={(self.relationship if hasattr(self, "relationship") else None)!s})')
