# -*- coding: utf-8 -*-

"""
akoyaapisv240

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
import dateutil.parser

from akoyaapisv240.api_helper import APIHelper
from akoyaapisv240.models.error_2 import Error2
from akoyaapisv240.models.hateoas_link import HATEOASLink
from akoyaapisv240.models.tax_form_attribute import TaxFormAttribute
from akoyaapisv240.models.tax_party_1 import TaxParty1
from akoyaapisv240.models.tax_party_8 import TaxParty8


class Form1099Q2(object):

    """Implementation of the 'Form 1099-Q2' model.

    Payments From Qualified Education Programs

    Attributes:
        tax_year (int): Year for which taxes are being paid
        corrected (bool): True to indicate this is a corrected tax form
        account_id (str): Long-term persistent identity of the source account.
            Not the account number
        tax_form_id (str): Long-term persistent id for this tax form.
            Depending upon the data provider, this may be the same id as the
            enclosing tax statement id, or this may be a different id, or this
            id may be omitted.
        tax_form_date (date): Date of production or delivery of the tax form
        additional_information (str): Additional explanation text or content
            about this tax form
        tax_form_type (TypeFormType2Enum): Enumerated name of the tax form
            entity e.g. "TaxW2"
        issuer (TaxParty8): Issuer's name, address, phone, and TIN. Issuer
            data need only be transmitted on enclosing TaxStatement, if it is
            the same on all its included tax forms.
        recipient (TaxParty1): Recipient's name, address, phone, and TIN.
            Recipient data need only be transmitted on enclosing TaxStatement,
            if it is the same on all its included tax forms.
        attributes (List[TaxFormAttribute]): Additional attributes for this
            tax form when defined fields are not available. Some specific
            additional attributes already defined by providers: Fields
            required by [IRS
            FIRE](https://www.irs.gov/e-file-providers/filing-information-retur
            ns-electronically-fire): Name Control, Type of Identification
            Number (EIN, SSN, ITIN, ATIN). (ATIN is tax ID number for pending
            adoptions.) Tax form provider field for taxpayer notification:
            Recipient Email Address.
        error (Error2): Present if an error was encountered while retrieving
            this form
        links (List[HATEOASLink]): Links to retrieve this form as data or
            image, or to invoke other APIs
        account_number (str): Account number
        gross_distribution (float): Box 1, Gross distribution
        earnings (float): Box 2, Earnings
        basis (float): Box 3, Basis
        trustee_to_trustee (bool): Box 4, Trustee-to-trustee transfer
        tuition_plan_private (bool): Box 5a, Qualified tuition plan - Private
        tuition_plan_public (bool): Box 5b, Qualified tuition plan - Public
        coverdell_esa (bool): Box 5c, Coverdell ESA
        recipient_is_not_beneficiary (bool): Box 6, If this box is checked,
            the recipient is not the designated beneficiary
        fair_market_value (float): If fair market value (FMV) is included, see
            Pub. 970, Tax Benefits for Education, for how to figure earnings

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "tax_year": 'taxYear',
        "corrected": 'corrected',
        "account_id": 'accountId',
        "tax_form_id": 'taxFormId',
        "tax_form_date": 'taxFormDate',
        "additional_information": 'additionalInformation',
        "tax_form_type": 'taxFormType',
        "issuer": 'issuer',
        "recipient": 'recipient',
        "attributes": 'attributes',
        "error": 'error',
        "links": 'links',
        "account_number": 'accountNumber',
        "gross_distribution": 'grossDistribution',
        "earnings": 'earnings',
        "basis": 'basis',
        "trustee_to_trustee": 'trusteeToTrustee',
        "tuition_plan_private": 'tuitionPlanPrivate',
        "tuition_plan_public": 'tuitionPlanPublic',
        "coverdell_esa": 'coverdellEsa',
        "recipient_is_not_beneficiary": 'recipientIsNotBeneficiary',
        "fair_market_value": 'fairMarketValue'
    }

    _optionals = [
        'tax_year',
        'corrected',
        'account_id',
        'tax_form_id',
        'tax_form_date',
        'additional_information',
        'tax_form_type',
        'issuer',
        'recipient',
        'attributes',
        'error',
        'links',
        'account_number',
        'gross_distribution',
        'earnings',
        'basis',
        'trustee_to_trustee',
        'tuition_plan_private',
        'tuition_plan_public',
        'coverdell_esa',
        'recipient_is_not_beneficiary',
        'fair_market_value',
    ]

    def __init__(self,
                 tax_year=APIHelper.SKIP,
                 corrected=APIHelper.SKIP,
                 account_id=APIHelper.SKIP,
                 tax_form_id=APIHelper.SKIP,
                 tax_form_date=APIHelper.SKIP,
                 additional_information=APIHelper.SKIP,
                 tax_form_type=APIHelper.SKIP,
                 issuer=APIHelper.SKIP,
                 recipient=APIHelper.SKIP,
                 attributes=APIHelper.SKIP,
                 error=APIHelper.SKIP,
                 links=APIHelper.SKIP,
                 account_number=APIHelper.SKIP,
                 gross_distribution=APIHelper.SKIP,
                 earnings=APIHelper.SKIP,
                 basis=APIHelper.SKIP,
                 trustee_to_trustee=APIHelper.SKIP,
                 tuition_plan_private=APIHelper.SKIP,
                 tuition_plan_public=APIHelper.SKIP,
                 coverdell_esa=APIHelper.SKIP,
                 recipient_is_not_beneficiary=APIHelper.SKIP,
                 fair_market_value=APIHelper.SKIP):
        """Constructor for the Form1099Q2 class"""

        # Initialize members of the class
        if tax_year is not APIHelper.SKIP:
            self.tax_year = tax_year 
        if corrected is not APIHelper.SKIP:
            self.corrected = corrected 
        if account_id is not APIHelper.SKIP:
            self.account_id = account_id 
        if tax_form_id is not APIHelper.SKIP:
            self.tax_form_id = tax_form_id 
        if tax_form_date is not APIHelper.SKIP:
            self.tax_form_date = tax_form_date 
        if additional_information is not APIHelper.SKIP:
            self.additional_information = additional_information 
        if tax_form_type is not APIHelper.SKIP:
            self.tax_form_type = tax_form_type 
        if issuer is not APIHelper.SKIP:
            self.issuer = issuer 
        if recipient is not APIHelper.SKIP:
            self.recipient = recipient 
        if attributes is not APIHelper.SKIP:
            self.attributes = attributes 
        if error is not APIHelper.SKIP:
            self.error = error 
        if links is not APIHelper.SKIP:
            self.links = links 
        if account_number is not APIHelper.SKIP:
            self.account_number = account_number 
        if gross_distribution is not APIHelper.SKIP:
            self.gross_distribution = gross_distribution 
        if earnings is not APIHelper.SKIP:
            self.earnings = earnings 
        if basis is not APIHelper.SKIP:
            self.basis = basis 
        if trustee_to_trustee is not APIHelper.SKIP:
            self.trustee_to_trustee = trustee_to_trustee 
        if tuition_plan_private is not APIHelper.SKIP:
            self.tuition_plan_private = tuition_plan_private 
        if tuition_plan_public is not APIHelper.SKIP:
            self.tuition_plan_public = tuition_plan_public 
        if coverdell_esa is not APIHelper.SKIP:
            self.coverdell_esa = coverdell_esa 
        if recipient_is_not_beneficiary is not APIHelper.SKIP:
            self.recipient_is_not_beneficiary = recipient_is_not_beneficiary 
        if fair_market_value is not APIHelper.SKIP:
            self.fair_market_value = fair_market_value 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        tax_year = dictionary.get("taxYear") if dictionary.get("taxYear") else APIHelper.SKIP
        corrected = dictionary.get("corrected") if "corrected" in dictionary.keys() else APIHelper.SKIP
        account_id = dictionary.get("accountId") if dictionary.get("accountId") else APIHelper.SKIP
        tax_form_id = dictionary.get("taxFormId") if dictionary.get("taxFormId") else APIHelper.SKIP
        tax_form_date = dateutil.parser.parse(dictionary.get('taxFormDate')).date() if dictionary.get('taxFormDate') else APIHelper.SKIP
        additional_information = dictionary.get("additionalInformation") if dictionary.get("additionalInformation") else APIHelper.SKIP
        tax_form_type = dictionary.get("taxFormType") if dictionary.get("taxFormType") else APIHelper.SKIP
        issuer = TaxParty8.from_dictionary(dictionary.get('issuer')) if 'issuer' in dictionary.keys() else APIHelper.SKIP
        recipient = TaxParty1.from_dictionary(dictionary.get('recipient')) if 'recipient' in dictionary.keys() else APIHelper.SKIP
        attributes = None
        if dictionary.get('attributes') is not None:
            attributes = [TaxFormAttribute.from_dictionary(x) for x in dictionary.get('attributes')]
        else:
            attributes = APIHelper.SKIP
        error = Error2.from_dictionary(dictionary.get('error')) if 'error' in dictionary.keys() else APIHelper.SKIP
        links = None
        if dictionary.get('links') is not None:
            links = [HATEOASLink.from_dictionary(x) for x in dictionary.get('links')]
        else:
            links = APIHelper.SKIP
        account_number = dictionary.get("accountNumber") if dictionary.get("accountNumber") else APIHelper.SKIP
        gross_distribution = dictionary.get("grossDistribution") if dictionary.get("grossDistribution") else APIHelper.SKIP
        earnings = dictionary.get("earnings") if dictionary.get("earnings") else APIHelper.SKIP
        basis = dictionary.get("basis") if dictionary.get("basis") else APIHelper.SKIP
        trustee_to_trustee = dictionary.get("trusteeToTrustee") if "trusteeToTrustee" in dictionary.keys() else APIHelper.SKIP
        tuition_plan_private = dictionary.get("tuitionPlanPrivate") if "tuitionPlanPrivate" in dictionary.keys() else APIHelper.SKIP
        tuition_plan_public = dictionary.get("tuitionPlanPublic") if "tuitionPlanPublic" in dictionary.keys() else APIHelper.SKIP
        coverdell_esa = dictionary.get("coverdellEsa") if "coverdellEsa" in dictionary.keys() else APIHelper.SKIP
        recipient_is_not_beneficiary = dictionary.get("recipientIsNotBeneficiary") if "recipientIsNotBeneficiary" in dictionary.keys() else APIHelper.SKIP
        fair_market_value = dictionary.get("fairMarketValue") if dictionary.get("fairMarketValue") else APIHelper.SKIP
        # Return an object of this model
        return cls(tax_year,
                   corrected,
                   account_id,
                   tax_form_id,
                   tax_form_date,
                   additional_information,
                   tax_form_type,
                   issuer,
                   recipient,
                   attributes,
                   error,
                   links,
                   account_number,
                   gross_distribution,
                   earnings,
                   basis,
                   trustee_to_trustee,
                   tuition_plan_private,
                   tuition_plan_public,
                   coverdell_esa,
                   recipient_is_not_beneficiary,
                   fair_market_value)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'tax_year={(self.tax_year if hasattr(self, "tax_year") else None)!r}, '
                f'corrected={(self.corrected if hasattr(self, "corrected") else None)!r}, '
                f'account_id={(self.account_id if hasattr(self, "account_id") else None)!r}, '
                f'tax_form_id={(self.tax_form_id if hasattr(self, "tax_form_id") else None)!r}, '
                f'tax_form_date={(self.tax_form_date if hasattr(self, "tax_form_date") else None)!r}, '
                f'additional_information={(self.additional_information if hasattr(self, "additional_information") else None)!r}, '
                f'tax_form_type={(self.tax_form_type if hasattr(self, "tax_form_type") else None)!r}, '
                f'issuer={(self.issuer if hasattr(self, "issuer") else None)!r}, '
                f'recipient={(self.recipient if hasattr(self, "recipient") else None)!r}, '
                f'attributes={(self.attributes if hasattr(self, "attributes") else None)!r}, '
                f'error={(self.error if hasattr(self, "error") else None)!r}, '
                f'links={(self.links if hasattr(self, "links") else None)!r}, '
                f'account_number={(self.account_number if hasattr(self, "account_number") else None)!r}, '
                f'gross_distribution={(self.gross_distribution if hasattr(self, "gross_distribution") else None)!r}, '
                f'earnings={(self.earnings if hasattr(self, "earnings") else None)!r}, '
                f'basis={(self.basis if hasattr(self, "basis") else None)!r}, '
                f'trustee_to_trustee={(self.trustee_to_trustee if hasattr(self, "trustee_to_trustee") else None)!r}, '
                f'tuition_plan_private={(self.tuition_plan_private if hasattr(self, "tuition_plan_private") else None)!r}, '
                f'tuition_plan_public={(self.tuition_plan_public if hasattr(self, "tuition_plan_public") else None)!r}, '
                f'coverdell_esa={(self.coverdell_esa if hasattr(self, "coverdell_esa") else None)!r}, '
                f'recipient_is_not_beneficiary={(self.recipient_is_not_beneficiary if hasattr(self, "recipient_is_not_beneficiary") else None)!r}, '
                f'fair_market_value={(self.fair_market_value if hasattr(self, "fair_market_value") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'tax_year={(self.tax_year if hasattr(self, "tax_year") else None)!s}, '
                f'corrected={(self.corrected if hasattr(self, "corrected") else None)!s}, '
                f'account_id={(self.account_id if hasattr(self, "account_id") else None)!s}, '
                f'tax_form_id={(self.tax_form_id if hasattr(self, "tax_form_id") else None)!s}, '
                f'tax_form_date={(self.tax_form_date if hasattr(self, "tax_form_date") else None)!s}, '
                f'additional_information={(self.additional_information if hasattr(self, "additional_information") else None)!s}, '
                f'tax_form_type={(self.tax_form_type if hasattr(self, "tax_form_type") else None)!s}, '
                f'issuer={(self.issuer if hasattr(self, "issuer") else None)!s}, '
                f'recipient={(self.recipient if hasattr(self, "recipient") else None)!s}, '
                f'attributes={(self.attributes if hasattr(self, "attributes") else None)!s}, '
                f'error={(self.error if hasattr(self, "error") else None)!s}, '
                f'links={(self.links if hasattr(self, "links") else None)!s}, '
                f'account_number={(self.account_number if hasattr(self, "account_number") else None)!s}, '
                f'gross_distribution={(self.gross_distribution if hasattr(self, "gross_distribution") else None)!s}, '
                f'earnings={(self.earnings if hasattr(self, "earnings") else None)!s}, '
                f'basis={(self.basis if hasattr(self, "basis") else None)!s}, '
                f'trustee_to_trustee={(self.trustee_to_trustee if hasattr(self, "trustee_to_trustee") else None)!s}, '
                f'tuition_plan_private={(self.tuition_plan_private if hasattr(self, "tuition_plan_private") else None)!s}, '
                f'tuition_plan_public={(self.tuition_plan_public if hasattr(self, "tuition_plan_public") else None)!s}, '
                f'coverdell_esa={(self.coverdell_esa if hasattr(self, "coverdell_esa") else None)!s}, '
                f'recipient_is_not_beneficiary={(self.recipient_is_not_beneficiary if hasattr(self, "recipient_is_not_beneficiary") else None)!s}, '
                f'fair_market_value={(self.fair_market_value if hasattr(self, "fair_market_value") else None)!s})')
