# -*- coding: utf-8 -*-

"""
akoyaapisv240

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from akoyaapisv240.api_helper import APIHelper
from akoyaapisv240.models.currency_entity import CurrencyEntity
from akoyaapisv240.models.fi_attribute_entity import FiAttributeEntity


class LineOfCreditBalances(object):

    """Implementation of the 'Line of credit balances' model.

    Data elements included with balances specific to line of credit accounts

    Attributes:
        account_id (str): Long-term persistent identity of the account. Not an
            account number. This identity must be unique to the owning
            institution.
        account_type (str): The type of an account. For instance, CHECKING,
            SAVINGS, 401K, etc.
        account_number_display (str): Account display number for the end
            user’s handle at owning institution. This is to be displayed by
            the Interface Provider.
        currency (CurrencyEntity): Indicates the currency code used by the
            account. May also include currency rate.
        description (str): The model property of type str.
        fi_attributes (List[FiAttributeEntity]): The model property of type
            List[FiAttributeEntity].
        nickname (str): Name given by the user. Used in UIs to assist in
            account selection
        product_name (str): Marketed product name for this account.  Used in
            UIs to assist in account selection
        status (StatusEnum): The status of an account.
        line_of_business (str): The line of business, such as consumer,
            consumer joint, small business, corporate, etc.
        balance_type (BalanceTypeEnum): ASSET (positive transaction amount
            increases balance), LIABILITY (positive transaction amount
            decreases balance)
        interest_rate (float): Interest Rate of Account
        interest_rate_type (InterestRateTypeEnum): The type of interest rate.
            FIXED or VARIABLE.
        interest_rate_as_of (datetime): Date of account’s interest rate
        last_activity_date (datetime): Date that last transaction occurred on
            account
        micr_number (str): MICR Number
        parent_account_id (str): Long-term persistent identity of the parent
            account. This is used to group accounts.
        prior_interest_rate (float): Previous Interest Rate of Account
        transfer_in (bool): Account is eligible for incoming transfers
        transfer_out (bool): Account is eligible for outgoing transfers
        balance_as_of (datetime): As-of date of balances
        advances_apr (float): Advances APR
        available_cash (float): Available cash
        available_credit (float): Available credit
        cash_advance_limit (float): Cash advance limit
        credit_line (float): Credit limit
        current_balance (float): Current balance LOC
        current_rewards_balance (float): Current rewards balance
        finance_charges (float): Finance charges
        last_payment_amount (float): Last payment amount
        last_payment_date (datetime): Last payment date
        last_stmt_balance (float): Last Statement Balance
        last_stmt_date (datetime): Last Statement Date
        minimum_payment_amount (float): Minimum payment amount
        next_payment_amount (float): Amount of next payment
        next_payment_date (datetime): Due date of next payment
        past_due_amount (float): Past Due Amount
        points_accrued (float): Points accrued
        principal_balance (float): Principal balance
        points_redeemed (float): Points redeemed
        purchases_apr (float): Purchases APR

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "account_id": 'accountId',
        "account_type": 'accountType',
        "account_number_display": 'accountNumberDisplay',
        "currency": 'currency',
        "description": 'description',
        "fi_attributes": 'fiAttributes',
        "nickname": 'nickname',
        "product_name": 'productName',
        "status": 'status',
        "line_of_business": 'lineOfBusiness',
        "balance_type": 'balanceType',
        "interest_rate": 'interestRate',
        "interest_rate_type": 'interestRateType',
        "interest_rate_as_of": 'interestRateAsOf',
        "last_activity_date": 'lastActivityDate',
        "micr_number": 'micrNumber',
        "parent_account_id": 'parentAccountId',
        "prior_interest_rate": 'priorInterestRate',
        "transfer_in": 'transferIn',
        "transfer_out": 'transferOut',
        "balance_as_of": 'balanceAsOf',
        "advances_apr": 'advancesApr',
        "available_cash": 'availableCash',
        "available_credit": 'availableCredit',
        "cash_advance_limit": 'cashAdvanceLimit',
        "credit_line": 'creditLine',
        "current_balance": 'currentBalance',
        "current_rewards_balance": 'currentRewardsBalance',
        "finance_charges": 'financeCharges',
        "last_payment_amount": 'lastPaymentAmount',
        "last_payment_date": 'lastPaymentDate',
        "last_stmt_balance": 'lastStmtBalance',
        "last_stmt_date": 'lastStmtDate',
        "minimum_payment_amount": 'minimumPaymentAmount',
        "next_payment_amount": 'nextPaymentAmount',
        "next_payment_date": 'nextPaymentDate',
        "past_due_amount": 'pastDueAmount',
        "points_accrued": 'pointsAccrued',
        "principal_balance": 'principalBalance',
        "points_redeemed": 'pointsRedeemed',
        "purchases_apr": 'purchasesApr'
    }

    _optionals = [
        'account_id',
        'account_type',
        'account_number_display',
        'currency',
        'description',
        'fi_attributes',
        'nickname',
        'product_name',
        'status',
        'line_of_business',
        'balance_type',
        'interest_rate',
        'interest_rate_type',
        'interest_rate_as_of',
        'last_activity_date',
        'micr_number',
        'parent_account_id',
        'prior_interest_rate',
        'transfer_in',
        'transfer_out',
        'balance_as_of',
        'advances_apr',
        'available_cash',
        'available_credit',
        'cash_advance_limit',
        'credit_line',
        'current_balance',
        'current_rewards_balance',
        'finance_charges',
        'last_payment_amount',
        'last_payment_date',
        'last_stmt_balance',
        'last_stmt_date',
        'minimum_payment_amount',
        'next_payment_amount',
        'next_payment_date',
        'past_due_amount',
        'points_accrued',
        'principal_balance',
        'points_redeemed',
        'purchases_apr',
    ]

    def __init__(self,
                 account_id=APIHelper.SKIP,
                 account_type=APIHelper.SKIP,
                 account_number_display=APIHelper.SKIP,
                 currency=APIHelper.SKIP,
                 description=APIHelper.SKIP,
                 fi_attributes=APIHelper.SKIP,
                 nickname=APIHelper.SKIP,
                 product_name=APIHelper.SKIP,
                 status=APIHelper.SKIP,
                 line_of_business=APIHelper.SKIP,
                 balance_type=APIHelper.SKIP,
                 interest_rate=APIHelper.SKIP,
                 interest_rate_type=APIHelper.SKIP,
                 interest_rate_as_of=APIHelper.SKIP,
                 last_activity_date=APIHelper.SKIP,
                 micr_number=APIHelper.SKIP,
                 parent_account_id=APIHelper.SKIP,
                 prior_interest_rate=APIHelper.SKIP,
                 transfer_in=APIHelper.SKIP,
                 transfer_out=APIHelper.SKIP,
                 balance_as_of=APIHelper.SKIP,
                 advances_apr=APIHelper.SKIP,
                 available_cash=APIHelper.SKIP,
                 available_credit=APIHelper.SKIP,
                 cash_advance_limit=APIHelper.SKIP,
                 credit_line=APIHelper.SKIP,
                 current_balance=APIHelper.SKIP,
                 current_rewards_balance=APIHelper.SKIP,
                 finance_charges=APIHelper.SKIP,
                 last_payment_amount=APIHelper.SKIP,
                 last_payment_date=APIHelper.SKIP,
                 last_stmt_balance=APIHelper.SKIP,
                 last_stmt_date=APIHelper.SKIP,
                 minimum_payment_amount=APIHelper.SKIP,
                 next_payment_amount=APIHelper.SKIP,
                 next_payment_date=APIHelper.SKIP,
                 past_due_amount=APIHelper.SKIP,
                 points_accrued=APIHelper.SKIP,
                 principal_balance=APIHelper.SKIP,
                 points_redeemed=APIHelper.SKIP,
                 purchases_apr=APIHelper.SKIP):
        """Constructor for the LineOfCreditBalances class"""

        # Initialize members of the class
        if account_id is not APIHelper.SKIP:
            self.account_id = account_id 
        if account_type is not APIHelper.SKIP:
            self.account_type = account_type 
        if account_number_display is not APIHelper.SKIP:
            self.account_number_display = account_number_display 
        if currency is not APIHelper.SKIP:
            self.currency = currency 
        if description is not APIHelper.SKIP:
            self.description = description 
        if fi_attributes is not APIHelper.SKIP:
            self.fi_attributes = fi_attributes 
        if nickname is not APIHelper.SKIP:
            self.nickname = nickname 
        if product_name is not APIHelper.SKIP:
            self.product_name = product_name 
        if status is not APIHelper.SKIP:
            self.status = status 
        if line_of_business is not APIHelper.SKIP:
            self.line_of_business = line_of_business 
        if balance_type is not APIHelper.SKIP:
            self.balance_type = balance_type 
        if interest_rate is not APIHelper.SKIP:
            self.interest_rate = interest_rate 
        if interest_rate_type is not APIHelper.SKIP:
            self.interest_rate_type = interest_rate_type 
        if interest_rate_as_of is not APIHelper.SKIP:
            self.interest_rate_as_of = APIHelper.apply_datetime_converter(interest_rate_as_of, APIHelper.RFC3339DateTime) if interest_rate_as_of else None 
        if last_activity_date is not APIHelper.SKIP:
            self.last_activity_date = APIHelper.apply_datetime_converter(last_activity_date, APIHelper.RFC3339DateTime) if last_activity_date else None 
        if micr_number is not APIHelper.SKIP:
            self.micr_number = micr_number 
        if parent_account_id is not APIHelper.SKIP:
            self.parent_account_id = parent_account_id 
        if prior_interest_rate is not APIHelper.SKIP:
            self.prior_interest_rate = prior_interest_rate 
        if transfer_in is not APIHelper.SKIP:
            self.transfer_in = transfer_in 
        if transfer_out is not APIHelper.SKIP:
            self.transfer_out = transfer_out 
        if balance_as_of is not APIHelper.SKIP:
            self.balance_as_of = APIHelper.apply_datetime_converter(balance_as_of, APIHelper.RFC3339DateTime) if balance_as_of else None 
        if advances_apr is not APIHelper.SKIP:
            self.advances_apr = advances_apr 
        if available_cash is not APIHelper.SKIP:
            self.available_cash = available_cash 
        if available_credit is not APIHelper.SKIP:
            self.available_credit = available_credit 
        if cash_advance_limit is not APIHelper.SKIP:
            self.cash_advance_limit = cash_advance_limit 
        if credit_line is not APIHelper.SKIP:
            self.credit_line = credit_line 
        if current_balance is not APIHelper.SKIP:
            self.current_balance = current_balance 
        if current_rewards_balance is not APIHelper.SKIP:
            self.current_rewards_balance = current_rewards_balance 
        if finance_charges is not APIHelper.SKIP:
            self.finance_charges = finance_charges 
        if last_payment_amount is not APIHelper.SKIP:
            self.last_payment_amount = last_payment_amount 
        if last_payment_date is not APIHelper.SKIP:
            self.last_payment_date = APIHelper.apply_datetime_converter(last_payment_date, APIHelper.RFC3339DateTime) if last_payment_date else None 
        if last_stmt_balance is not APIHelper.SKIP:
            self.last_stmt_balance = last_stmt_balance 
        if last_stmt_date is not APIHelper.SKIP:
            self.last_stmt_date = APIHelper.apply_datetime_converter(last_stmt_date, APIHelper.RFC3339DateTime) if last_stmt_date else None 
        if minimum_payment_amount is not APIHelper.SKIP:
            self.minimum_payment_amount = minimum_payment_amount 
        if next_payment_amount is not APIHelper.SKIP:
            self.next_payment_amount = next_payment_amount 
        if next_payment_date is not APIHelper.SKIP:
            self.next_payment_date = APIHelper.apply_datetime_converter(next_payment_date, APIHelper.RFC3339DateTime) if next_payment_date else None 
        if past_due_amount is not APIHelper.SKIP:
            self.past_due_amount = past_due_amount 
        if points_accrued is not APIHelper.SKIP:
            self.points_accrued = points_accrued 
        if principal_balance is not APIHelper.SKIP:
            self.principal_balance = principal_balance 
        if points_redeemed is not APIHelper.SKIP:
            self.points_redeemed = points_redeemed 
        if purchases_apr is not APIHelper.SKIP:
            self.purchases_apr = purchases_apr 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        account_id = dictionary.get("accountId") if dictionary.get("accountId") else APIHelper.SKIP
        account_type = dictionary.get("accountType") if dictionary.get("accountType") else APIHelper.SKIP
        account_number_display = dictionary.get("accountNumberDisplay") if dictionary.get("accountNumberDisplay") else APIHelper.SKIP
        currency = CurrencyEntity.from_dictionary(dictionary.get('currency')) if 'currency' in dictionary.keys() else APIHelper.SKIP
        description = dictionary.get("description") if dictionary.get("description") else APIHelper.SKIP
        fi_attributes = None
        if dictionary.get('fiAttributes') is not None:
            fi_attributes = [FiAttributeEntity.from_dictionary(x) for x in dictionary.get('fiAttributes')]
        else:
            fi_attributes = APIHelper.SKIP
        nickname = dictionary.get("nickname") if dictionary.get("nickname") else APIHelper.SKIP
        product_name = dictionary.get("productName") if dictionary.get("productName") else APIHelper.SKIP
        status = dictionary.get("status") if dictionary.get("status") else APIHelper.SKIP
        line_of_business = dictionary.get("lineOfBusiness") if dictionary.get("lineOfBusiness") else APIHelper.SKIP
        balance_type = dictionary.get("balanceType") if dictionary.get("balanceType") else APIHelper.SKIP
        interest_rate = dictionary.get("interestRate") if dictionary.get("interestRate") else APIHelper.SKIP
        interest_rate_type = dictionary.get("interestRateType") if dictionary.get("interestRateType") else APIHelper.SKIP
        interest_rate_as_of = APIHelper.RFC3339DateTime.from_value(dictionary.get("interestRateAsOf")).datetime if dictionary.get("interestRateAsOf") else APIHelper.SKIP
        last_activity_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("lastActivityDate")).datetime if dictionary.get("lastActivityDate") else APIHelper.SKIP
        micr_number = dictionary.get("micrNumber") if dictionary.get("micrNumber") else APIHelper.SKIP
        parent_account_id = dictionary.get("parentAccountId") if dictionary.get("parentAccountId") else APIHelper.SKIP
        prior_interest_rate = dictionary.get("priorInterestRate") if dictionary.get("priorInterestRate") else APIHelper.SKIP
        transfer_in = dictionary.get("transferIn") if "transferIn" in dictionary.keys() else APIHelper.SKIP
        transfer_out = dictionary.get("transferOut") if "transferOut" in dictionary.keys() else APIHelper.SKIP
        balance_as_of = APIHelper.RFC3339DateTime.from_value(dictionary.get("balanceAsOf")).datetime if dictionary.get("balanceAsOf") else APIHelper.SKIP
        advances_apr = dictionary.get("advancesApr") if dictionary.get("advancesApr") else APIHelper.SKIP
        available_cash = dictionary.get("availableCash") if dictionary.get("availableCash") else APIHelper.SKIP
        available_credit = dictionary.get("availableCredit") if dictionary.get("availableCredit") else APIHelper.SKIP
        cash_advance_limit = dictionary.get("cashAdvanceLimit") if dictionary.get("cashAdvanceLimit") else APIHelper.SKIP
        credit_line = dictionary.get("creditLine") if dictionary.get("creditLine") else APIHelper.SKIP
        current_balance = dictionary.get("currentBalance") if dictionary.get("currentBalance") else APIHelper.SKIP
        current_rewards_balance = dictionary.get("currentRewardsBalance") if dictionary.get("currentRewardsBalance") else APIHelper.SKIP
        finance_charges = dictionary.get("financeCharges") if dictionary.get("financeCharges") else APIHelper.SKIP
        last_payment_amount = dictionary.get("lastPaymentAmount") if dictionary.get("lastPaymentAmount") else APIHelper.SKIP
        last_payment_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("lastPaymentDate")).datetime if dictionary.get("lastPaymentDate") else APIHelper.SKIP
        last_stmt_balance = dictionary.get("lastStmtBalance") if dictionary.get("lastStmtBalance") else APIHelper.SKIP
        last_stmt_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("lastStmtDate")).datetime if dictionary.get("lastStmtDate") else APIHelper.SKIP
        minimum_payment_amount = dictionary.get("minimumPaymentAmount") if dictionary.get("minimumPaymentAmount") else APIHelper.SKIP
        next_payment_amount = dictionary.get("nextPaymentAmount") if dictionary.get("nextPaymentAmount") else APIHelper.SKIP
        next_payment_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("nextPaymentDate")).datetime if dictionary.get("nextPaymentDate") else APIHelper.SKIP
        past_due_amount = dictionary.get("pastDueAmount") if dictionary.get("pastDueAmount") else APIHelper.SKIP
        points_accrued = dictionary.get("pointsAccrued") if dictionary.get("pointsAccrued") else APIHelper.SKIP
        principal_balance = dictionary.get("principalBalance") if dictionary.get("principalBalance") else APIHelper.SKIP
        points_redeemed = dictionary.get("pointsRedeemed") if dictionary.get("pointsRedeemed") else APIHelper.SKIP
        purchases_apr = dictionary.get("purchasesApr") if dictionary.get("purchasesApr") else APIHelper.SKIP
        # Return an object of this model
        return cls(account_id,
                   account_type,
                   account_number_display,
                   currency,
                   description,
                   fi_attributes,
                   nickname,
                   product_name,
                   status,
                   line_of_business,
                   balance_type,
                   interest_rate,
                   interest_rate_type,
                   interest_rate_as_of,
                   last_activity_date,
                   micr_number,
                   parent_account_id,
                   prior_interest_rate,
                   transfer_in,
                   transfer_out,
                   balance_as_of,
                   advances_apr,
                   available_cash,
                   available_credit,
                   cash_advance_limit,
                   credit_line,
                   current_balance,
                   current_rewards_balance,
                   finance_charges,
                   last_payment_amount,
                   last_payment_date,
                   last_stmt_balance,
                   last_stmt_date,
                   minimum_payment_amount,
                   next_payment_amount,
                   next_payment_date,
                   past_due_amount,
                   points_accrued,
                   principal_balance,
                   points_redeemed,
                   purchases_apr)

    @classmethod
    def validate(cls, dictionary):
        """Validates dictionary against class required properties

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            boolean : if dictionary is valid contains required properties.

        """

        if isinstance(dictionary, cls):
            return True

        if not isinstance(dictionary, dict):
            return False

        return True

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'account_id={(self.account_id if hasattr(self, "account_id") else None)!r}, '
                f'account_type={(self.account_type if hasattr(self, "account_type") else None)!r}, '
                f'account_number_display={(self.account_number_display if hasattr(self, "account_number_display") else None)!r}, '
                f'currency={(self.currency if hasattr(self, "currency") else None)!r}, '
                f'description={(self.description if hasattr(self, "description") else None)!r}, '
                f'fi_attributes={(self.fi_attributes if hasattr(self, "fi_attributes") else None)!r}, '
                f'nickname={(self.nickname if hasattr(self, "nickname") else None)!r}, '
                f'product_name={(self.product_name if hasattr(self, "product_name") else None)!r}, '
                f'status={(self.status if hasattr(self, "status") else None)!r}, '
                f'line_of_business={(self.line_of_business if hasattr(self, "line_of_business") else None)!r}, '
                f'balance_type={(self.balance_type if hasattr(self, "balance_type") else None)!r}, '
                f'interest_rate={(self.interest_rate if hasattr(self, "interest_rate") else None)!r}, '
                f'interest_rate_type={(self.interest_rate_type if hasattr(self, "interest_rate_type") else None)!r}, '
                f'interest_rate_as_of={(self.interest_rate_as_of if hasattr(self, "interest_rate_as_of") else None)!r}, '
                f'last_activity_date={(self.last_activity_date if hasattr(self, "last_activity_date") else None)!r}, '
                f'micr_number={(self.micr_number if hasattr(self, "micr_number") else None)!r}, '
                f'parent_account_id={(self.parent_account_id if hasattr(self, "parent_account_id") else None)!r}, '
                f'prior_interest_rate={(self.prior_interest_rate if hasattr(self, "prior_interest_rate") else None)!r}, '
                f'transfer_in={(self.transfer_in if hasattr(self, "transfer_in") else None)!r}, '
                f'transfer_out={(self.transfer_out if hasattr(self, "transfer_out") else None)!r}, '
                f'balance_as_of={(self.balance_as_of if hasattr(self, "balance_as_of") else None)!r}, '
                f'advances_apr={(self.advances_apr if hasattr(self, "advances_apr") else None)!r}, '
                f'available_cash={(self.available_cash if hasattr(self, "available_cash") else None)!r}, '
                f'available_credit={(self.available_credit if hasattr(self, "available_credit") else None)!r}, '
                f'cash_advance_limit={(self.cash_advance_limit if hasattr(self, "cash_advance_limit") else None)!r}, '
                f'credit_line={(self.credit_line if hasattr(self, "credit_line") else None)!r}, '
                f'current_balance={(self.current_balance if hasattr(self, "current_balance") else None)!r}, '
                f'current_rewards_balance={(self.current_rewards_balance if hasattr(self, "current_rewards_balance") else None)!r}, '
                f'finance_charges={(self.finance_charges if hasattr(self, "finance_charges") else None)!r}, '
                f'last_payment_amount={(self.last_payment_amount if hasattr(self, "last_payment_amount") else None)!r}, '
                f'last_payment_date={(self.last_payment_date if hasattr(self, "last_payment_date") else None)!r}, '
                f'last_stmt_balance={(self.last_stmt_balance if hasattr(self, "last_stmt_balance") else None)!r}, '
                f'last_stmt_date={(self.last_stmt_date if hasattr(self, "last_stmt_date") else None)!r}, '
                f'minimum_payment_amount={(self.minimum_payment_amount if hasattr(self, "minimum_payment_amount") else None)!r}, '
                f'next_payment_amount={(self.next_payment_amount if hasattr(self, "next_payment_amount") else None)!r}, '
                f'next_payment_date={(self.next_payment_date if hasattr(self, "next_payment_date") else None)!r}, '
                f'past_due_amount={(self.past_due_amount if hasattr(self, "past_due_amount") else None)!r}, '
                f'points_accrued={(self.points_accrued if hasattr(self, "points_accrued") else None)!r}, '
                f'principal_balance={(self.principal_balance if hasattr(self, "principal_balance") else None)!r}, '
                f'points_redeemed={(self.points_redeemed if hasattr(self, "points_redeemed") else None)!r}, '
                f'purchases_apr={(self.purchases_apr if hasattr(self, "purchases_apr") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'account_id={(self.account_id if hasattr(self, "account_id") else None)!s}, '
                f'account_type={(self.account_type if hasattr(self, "account_type") else None)!s}, '
                f'account_number_display={(self.account_number_display if hasattr(self, "account_number_display") else None)!s}, '
                f'currency={(self.currency if hasattr(self, "currency") else None)!s}, '
                f'description={(self.description if hasattr(self, "description") else None)!s}, '
                f'fi_attributes={(self.fi_attributes if hasattr(self, "fi_attributes") else None)!s}, '
                f'nickname={(self.nickname if hasattr(self, "nickname") else None)!s}, '
                f'product_name={(self.product_name if hasattr(self, "product_name") else None)!s}, '
                f'status={(self.status if hasattr(self, "status") else None)!s}, '
                f'line_of_business={(self.line_of_business if hasattr(self, "line_of_business") else None)!s}, '
                f'balance_type={(self.balance_type if hasattr(self, "balance_type") else None)!s}, '
                f'interest_rate={(self.interest_rate if hasattr(self, "interest_rate") else None)!s}, '
                f'interest_rate_type={(self.interest_rate_type if hasattr(self, "interest_rate_type") else None)!s}, '
                f'interest_rate_as_of={(self.interest_rate_as_of if hasattr(self, "interest_rate_as_of") else None)!s}, '
                f'last_activity_date={(self.last_activity_date if hasattr(self, "last_activity_date") else None)!s}, '
                f'micr_number={(self.micr_number if hasattr(self, "micr_number") else None)!s}, '
                f'parent_account_id={(self.parent_account_id if hasattr(self, "parent_account_id") else None)!s}, '
                f'prior_interest_rate={(self.prior_interest_rate if hasattr(self, "prior_interest_rate") else None)!s}, '
                f'transfer_in={(self.transfer_in if hasattr(self, "transfer_in") else None)!s}, '
                f'transfer_out={(self.transfer_out if hasattr(self, "transfer_out") else None)!s}, '
                f'balance_as_of={(self.balance_as_of if hasattr(self, "balance_as_of") else None)!s}, '
                f'advances_apr={(self.advances_apr if hasattr(self, "advances_apr") else None)!s}, '
                f'available_cash={(self.available_cash if hasattr(self, "available_cash") else None)!s}, '
                f'available_credit={(self.available_credit if hasattr(self, "available_credit") else None)!s}, '
                f'cash_advance_limit={(self.cash_advance_limit if hasattr(self, "cash_advance_limit") else None)!s}, '
                f'credit_line={(self.credit_line if hasattr(self, "credit_line") else None)!s}, '
                f'current_balance={(self.current_balance if hasattr(self, "current_balance") else None)!s}, '
                f'current_rewards_balance={(self.current_rewards_balance if hasattr(self, "current_rewards_balance") else None)!s}, '
                f'finance_charges={(self.finance_charges if hasattr(self, "finance_charges") else None)!s}, '
                f'last_payment_amount={(self.last_payment_amount if hasattr(self, "last_payment_amount") else None)!s}, '
                f'last_payment_date={(self.last_payment_date if hasattr(self, "last_payment_date") else None)!s}, '
                f'last_stmt_balance={(self.last_stmt_balance if hasattr(self, "last_stmt_balance") else None)!s}, '
                f'last_stmt_date={(self.last_stmt_date if hasattr(self, "last_stmt_date") else None)!s}, '
                f'minimum_payment_amount={(self.minimum_payment_amount if hasattr(self, "minimum_payment_amount") else None)!s}, '
                f'next_payment_amount={(self.next_payment_amount if hasattr(self, "next_payment_amount") else None)!s}, '
                f'next_payment_date={(self.next_payment_date if hasattr(self, "next_payment_date") else None)!s}, '
                f'past_due_amount={(self.past_due_amount if hasattr(self, "past_due_amount") else None)!s}, '
                f'points_accrued={(self.points_accrued if hasattr(self, "points_accrued") else None)!s}, '
                f'principal_balance={(self.principal_balance if hasattr(self, "principal_balance") else None)!s}, '
                f'points_redeemed={(self.points_redeemed if hasattr(self, "points_redeemed") else None)!s}, '
                f'purchases_apr={(self.purchases_apr if hasattr(self, "purchases_apr") else None)!s})')
