# -*- coding: utf-8 -*-

"""
akoyaapisv240

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from akoyaapisv240.api_helper import APIHelper
from akoyaapisv240.models.local_tax_withholding_1 import LocalTaxWithholding1
from akoyaapisv240.models.state_tax_withholding_2 import StateTaxWithholding2


class StateAndLocalTaxWithholding(object):

    """Implementation of the 'State and Local Tax Withholding' model.

    Income in a state and/or locality and its or their tax withholding

    Attributes:
        state_code (StateCode2Enum): State two-digit code
        state (StateTaxWithholding2): Amount of state income tax withheld
        local (LocalTaxWithholding1): Amount of local income tax withheld, if
            any

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "state_code": 'stateCode',
        "state": 'state',
        "local": 'local'
    }

    _optionals = [
        'state_code',
        'state',
        'local',
    ]

    def __init__(self,
                 state_code=APIHelper.SKIP,
                 state=APIHelper.SKIP,
                 local=APIHelper.SKIP):
        """Constructor for the StateAndLocalTaxWithholding class"""

        # Initialize members of the class
        if state_code is not APIHelper.SKIP:
            self.state_code = state_code 
        if state is not APIHelper.SKIP:
            self.state = state 
        if local is not APIHelper.SKIP:
            self.local = local 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        state_code = dictionary.get("stateCode") if dictionary.get("stateCode") else APIHelper.SKIP
        state = StateTaxWithholding2.from_dictionary(dictionary.get('state')) if 'state' in dictionary.keys() else APIHelper.SKIP
        local = LocalTaxWithholding1.from_dictionary(dictionary.get('local')) if 'local' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(state_code,
                   state,
                   local)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'state_code={(self.state_code if hasattr(self, "state_code") else None)!r}, '
                f'state={(self.state if hasattr(self, "state") else None)!r}, '
                f'local={(self.local if hasattr(self, "local") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'state_code={(self.state_code if hasattr(self, "state_code") else None)!s}, '
                f'state={(self.state if hasattr(self, "state") else None)!s}, '
                f'local={(self.local if hasattr(self, "local") else None)!s})')
